<?php
// Obtener la carpeta actual
$carpeta = __DIR__;

// Escanear la carpeta para obtener todos los archivos
$archivos = scandir($carpeta);

// Array para almacenar los archivos con sus fechas de creación
$archivosConFechas = [];

// Recorrer los archivos encontrados
foreach ($archivos as $archivo) {
    // Omitir los directorios . y ..
    if ($archivo != "." && $archivo != "..") {
        // Obtener la ruta completa del archivo
        $rutaArchivo = $carpeta . DIRECTORY_SEPARATOR . $archivo;
        
        // Verificar si es un archivo
        if (is_file($rutaArchivo)) {
            // Obtener la fecha de creación del archivo
            $fechaCreacion = filectime($rutaArchivo);
            
            // Guardar en el array con nombre y fecha
            $archivosConFechas[] = [
                'nombre' => $archivo,
                'fecha_creacion' => date("d-m-Y H:i:s", $fechaCreacion) // Convertir a formato legible
            ];
        }
    }
}

// Ordenar el array por fecha de creación (más nuevo a más viejo)
usort($archivosConFechas, function ($a, $b) {
    return strtotime($b['fecha_creacion']) - strtotime($a['fecha_creacion']);
});

// Convertir el array a JSON y mostrarlo
header('Content-Type: application/json');
echo json_encode($archivosConFechas, JSON_PRETTY_PRINT);
?>
