<?php
/**
*
*/

// Disallow direct access.
defined('ABSPATH') or die("Access denied");

/**
*
*/
class ECMEHDBlocksController
extends CJTAjaxController
{

    /**
    * put your comment there...
    *
    * @var mixed
    */
    protected $controllerInfo = array
    (
        'model' => 'blocks',
    );

    /**
    * Initialize controller object.
    *
    * @see CJTController for more details
    * @return void
    */
    public function __construct($hasView = null,
                                $request = null,
                                $overrideControllerPath = null,
                                $overrideContollerPrefix = null)
    {

        parent::__construct(
            $hasView,
            $request,
            $overrideControllerPath,
            $overrideContollerPrefix
        );

        // Supported actions.
        $this->registryAction('get_revision');
        $this->registryAction('get_revisions');
        $this->registryAction('restoreRevision');
        $this->registryAction('loadUrl');
        $this->registryAction('minify');
    }

    /**
    * put your comment there...
    *
    */
    public function minifyAction()
    {

        $editorLang = $_REQUEST['editLang'];
        $content = filter_input(INPUT_POST, 'content', FILTER_UNSAFE_RAW);

        try
        {

            switch ($editorLang)
            {

                case 'css':
                case 'javascript':

                    $minifierTypes = array
                    (
                        'css' => 'CSS',
                        'javascript' => 'JS'
                    );

                    $minifierClass = '\MatthiasMullie\Minify\\' . $minifierTypes[$editorLang];

                    $minifier = new $minifierClass();
                    $minifier->add($content);

                    $this->response = $minifier->minify();

                break;

                case 'html':

                    $content = preg_replace(array('/\>\s+/', '/\s+\</'), array('>', '<'), $content);

                    $jsMinifier = new MatthiasMullie\Minify\JS();
                    $jsMinifier->add($content);

                    $content = $jsMinifier->minify();

                    $cssMinifer = new MatthiasMullie\Minify\CSS();
                    $cssMinifer->add($content);

                    $content = $cssMinifer->minify();

                    $this->response = $content;
                break;
            }
        }
        catch (Exception $exception)
        {
            $this->response = $exception->getMessage();
        }
    }

    /**
    * put your comment there...
    *
    * @deprecated All will be moved to other controllers in the future versions.
    */
    public function getRevisionAction() {
        // Initialize
        $tblCodeFile = new CJTBlockFilesTable(cssJSToolbox::getInstance()->getDBDriver());
        // Inputs.
        $revisionId = filter_input(INPUT_GET, 'id', FILTER_SANITIZE_NUMBER_INT);
        // Get request parameters.
        $revision['id'] = $revisionId;
        $revision['fields'] = array('id', 'links', 'expressions', 'masterFile');
        $revision = $this->model->getBlock($revision['id'], array(), $revision['fields']);
        // Get revisioned code file.
        $revision->code = $tblCodeFile->set('blockId', $revisionId)
        ->set('id', $revision->masterFile)
        ->load()
        ->getData()->code;
        // Discard Pins.
        $customPins = array_keys( CJTBlockModel::getCustomPins() );

        foreach ( $customPins as $customPinName )
        {
            $revision->{$customPinName} = false;
        }

        // Return revision.
        $this->response = $revision;
    }

    /**
    * put your comment there...
    *
    * @deprecated All will be moved to other controllers in the future versions.
    */
    public function getRevisionsAction()
    {

        // Get request parameters.
        $blockId = filter_input(INPUT_GET, 'id', FILTER_SANITIZE_NUMBER_INT);
        // Get block revisions.
        $revisions['filter']['masterFile'] = $_GET['activeFileId'];
        $revisions['filter']['parent'] = $blockId;
        $revisions['filter']['type'] = 'revision';
        // Its mandatory to select fields instead of using just .*.
        // This is because id field must be first to be used as the array key
        $revisions['fields'] = array('id', 'name', 'created', 'lastModified', 'owner');
        // Query getBlocks without ids filter or backup.
        $revisions = $this->model->getBlocks(null, $revisions['filter'], $revisions['fields']);
        // Create view.
        $view = $this->getView('blocks/revisions', null, $this->overridePath, $this->overridePrefix);
        // Push view vars.
        $view->blockId = $blockId;
        $view->revisions = $revisions;
        // Set output header.
        $this->httpContentType = 'text/html';
        // Return view content.
        $this->response = $view->getTemplate('default');
    }

    /**
    * put your comment there...
    *
    * @deprecated this is just a redirect to the CJTBlockContoller::getAction().
    */
    protected function loadUrlAction()
    {
        // Read inputs.
        $url = isset( $_GET['url'] ) ? $_GET['url'] : '';
        // Read URL.
        $response = wp_remote_get($url);
        if ($error = $response instanceof WP_Error) {
            // State an error!
            $this->response['errorCode'] = $response->get_error_code();
            $this->response['message'] = $response->get_error_message($response['code']);
            //break;
        }
        else {
            // Read code content.
            $this->response['content'] = wp_remote_retrieve_body($response);
        }
    }

    /**
    * put your comment there...
    *
    */
    protected function restoreRevisionAction() {
        // Initialize.
        $mdlBlocks = new CJTBlocksModel();
        $tblCodeFile = new CJTBlockFilesTable(cssJSToolbox::getInstance()->getDBDriver());
        // Get revision ID.
        $rId = isset( $_GET['rid'] ) ? (int) $_GET['rid'] : false;
        $bId = isset( $_GET['bid'] ) ? (int) $_GET['bid'] : false;
        // Get Revision Block + Revision Code.
        $revisionBlock = $mdlBlocks->getBlock($rId, array(), array('id', 'pinPoint', 'links', 'expressions', 'masterFile'));
        $revisionBlock->code = $tblCodeFile->set('blockId', $rId)
        ->set('id', $revisionBlock->masterFile)
        ->load()
        ->getData()->code;
        // If code === null set it to empoty string '' as null woulod
        // prevent the field from being in the query, cause SQL error.
        if ($revisionBlock->code === null) {
            $revisionBlock->code = '';
        }
        // Code File Fields.
        $revisionBlock->activeFileId = $revisionBlock->masterFile;
        $revisionBlock->masterFile = null; // This is just for querying CodeFile. DONT UPDATE.
        // Restore Block.
        $revisionBlock->id = $bId;
        $mdlBlocks->update($revisionBlock, true);
        $mdlBlocks->save();
        // Return TRUE.
        $this->response = true;
    }

}