<?php
/**
* 
*/

/**
* 
*/
class CJTPlusBlockShortcodesController extends CJTServicesMVCController
{
	
	/**
	* put your comment there...
	* 
	*/
	public function blockParametersFormAction() 
	{
		// Get block id.
		$blockId = ( int ) $_REQUEST[ 'blockId' ];
		
		// Get block form!
		$form = CJTxTable::getInstance( 'form' )->setTableKey( array( 'blockId' ) )
																						->setData( array( 'blockId' => $blockId ) )
																						->load();
		
		$viewArgs = null;
		
		// Display form view.
		if ( $form->get( 'blockId' ) ) 
		{
			// Load parameters form.
			$groups = new CJT_Models_Block_Parameters_Form_Groups( $blockId );
			$params = new CJT_Models_Block_Parameters_Form_Parameters( $blockId );
			$blockParams = new CJT_Framework_View_Block_Parameter_Parameters( $params );
			
			$viewArgs = array
			(
				'groups' => $groups,
				'params' => $blockParams->getParams(),
				'form' => $form->getData(),
				'blockId' => $blockId
			);
			
			$viewArgs[ 'securityToken' ] = wp_create_nonce();
		}
		
		return $viewArgs;
	}

	/**
	* put your comment there...
	* 
	*/
	public function getBlocksListAction() 
	{
		// Read all blocks!
		$response = array();
		
		$model =& $this->getModel( 'BlockGeneric' );
		$blocks = $model->getShortcodeBlocksList();
		
		// retreive owener name!
		foreach ( $blocks as $id => $block ) 
		{
			$user = get_userdata( $block->owner );
			$block->owner = ! $user ? 'N/A' : $user->display_name;
			
			$response[ 'list' ][ $id ] = $block;
		}
		
		$response[ 'count' ] = count( $response[ 'list' ] );
		
		return $response;
	}
	
	/**
	* put your comment there...
	* 
	*/
	public function getShortcodeAction() 
	{
		// Get block id.
		$response = array();
		$blockId = $_REQUEST[ 'blockId' ];
		
		// Load block
		$block = CJTxTable::getInstance( 'block' )
																	->setTableKey( array( 'id' ) )
																	->setData( array( 'id' => $blockId ) )
																	->load()
																	->getData();
																	
		$blockForm = (array) CJTxTable::getInstance( 'form' )
																	->setTableKey( array( 'blockId' ) )
																	->setData( array( 'blockId' => $blockId ) )
																	->load()
																	->getData();
		// Load block parameters.
		$parameters = new CJT_Models_Block_Parameters_Parameters( $blockId );
		$blockParams = new CJT_Framework_Developer_Interface_Block_Shortcode_Parameters_Parameters( $parameters );
		
		// The the block has FORM associated 
		if ( isset( $blockForm[ 'blockId' ] ) ) 
		{
			// If the data is submitted then load the parameters object with the post data!
			if ( $_SERVER[ 'REQUEST_METHOD' ] == 'POST' ) 
			{
				// Get RAW data from the data submitted (avoid magic_quotes, Why called MAGIC!!!!)!
				$rawPostData = filter_input( INPUT_POST, 'form-data', FILTER_UNSAFE_RAW, FILTER_REQUIRE_ARRAY );
				
				// Fill the form by the posted data
				$blockParams->setValue( $rawPostData );
				
				// Validate the submitted data against their parameters.
				if ( $blockParams->validate() ) 
				{
					// Generate and Return Shortcode string!
					 $response[ 'state' ] = 'shortcode-notation';
					 $response[ 'content' ] = $blockParams->shortcode( $block->name );
				}
				else {
					 $response[ 'state' ] = 'invalid';
					 $response[ 'content' ] = $blockParams->getMessages();					
				}
				
			}
			// Redirect to the parameters form view!
			else 
			{
				$response[ 'state' ] = 'show-form';
			}
		}
		else 
		{
			// If block doesn't has a parameters defined return
			// the Shortcode code string from the parameters loader.
			$response[ 'state' ] = 'shortcode-notation';
			$response[ 'content' ] = $blockParams->shortcode( $block->name );
		}
		
		return $response;
	}
	
}
	