<?php
/**
* 
*/

/**
* 
*/
class CJTPlusMSDashboardPanelController extends CJTServicesMVCController
{
	
	/**
	* put your comment there...
	* 
	*/
	public function indexAction()
	{
		
		if ( ! is_multisite() || ! is_super_admin() )
		{
			die( 'Access Denied' );
		}
		
		$model =& $this->getModel();
		$form = new CJTPlusMSDashboardPanelForm( );
		
		$viewParams = array();
		$viewParams[ 'form' ] =& $form;
		$viewParams[ 'securityToken' ] = wp_create_nonce();
		
		
		# Display 
		if ( $_SERVER[ 'REQUEST_METHOD'] != 'POST' )
		{
			
			$form->setArray( $model->getData() );
			
			return $viewParams;
		}
		
		$postFormData = filter_input( INPUT_POST, 'cjtms_form_data', FILTER_UNSAFE_RAW, FILTER_REQUIRE_ARRAY );
		
		$form->setArray( $postFormData );
		
		# Verify post nonce
		if ( 	! isset( $_POST[ 'securityToken' ] ) || 
					! $_POST[ 'securityToken' ] ||
					! wp_verify_nonce( $_POST[ 'securityToken' ] ) )
		{
			die( 'Not permitted to take such an action' );
		}
		
		# Save
		if ( $form->validate() && $model->validate( $postFormData ) )
		{
			
			$model->setData( $form->getArray() );
			
			$this->redirect( network_admin_url( 'admin.php?page=cjtms-dashboard' ) );	
		}
			
		return $viewParams;
	}
	
	/**
	* put your comment there...
	* 
	*/
	public function findSitesAction()
	{
		
		if ( 	! is_multisite() || 
					! is_super_admin() ||
					! isset( $_POST[ 'securityToken' ] ) ||
					! $_POST[ 'securityToken'] ||
					! wp_verify_nonce( $_POST[ 'securityToken' ] ) )
		{
			die( 'Access Denied' );
		}
		
		$model =& $this->getModel();
		
		# Inputs
		$queryTerm = $_POST[ 'query' ];
		$limit = $_POST[ 'limit' ];
		
		# Return sites
		$sites = $model->findSites( $queryTerm, $limit );
		
		return array( 'list' => $sites, 'resultCount' => count( $sites ) );
	}
	
	/**
	* put your comment there...
	* 
	*/
	public function findUsersAction()
	{
		
		if ( 	! is_multisite() || 
					! is_super_admin() ||
					! isset( $_POST[ 'securityToken' ] ) ||
					! $_POST[ 'securityToken'] ||
					! wp_verify_nonce( $_POST[ 'securityToken' ] ) )
		{
			die( 'Access Denied' );
		}
		
		
		$model =& $this->getModel();
		
		# Inputs
		$queryTerm = $_POST[ 'query' ];
		$limit = $_POST[ 'limit' ];
		
		# Return sites
		$users = $model->findUsers( $queryTerm, $limit );
		
		return array( 'list' => $users, 'resultCount' => count( $users ) );
		
	}
	
}
