<?php
/**
*
*/

// Disallow direct access.
defined('ABSPATH') or die("Access denied");

// Suppress Print scripts hook
global $wp_actions;

$wp_actions['wp_print_scripts'] = true;

// Initialize.
$blockId = $this->blockId;

// Block Package info.
$packageInfo = new CJT_Models_Package_Block( $blockId );
$packageInfo = $packageInfo->getPackageInfo();

// Prepare groups array.
$preparedGroups = array();

foreach ( $this->groups as $group )
{

	$group[ 'params' ] = array();

	// Group Key.
	$group[ 'key' ] = strtolower( str_replace( array( ' ' ), '-', $group[ 'name' ] ) );

	// Get group data copy.
	$preparedGroups[ $group[ 'id' ] ] = $group;

}

// Put the Group woth the loest ID first,
// Display in the same order they're added!
ksort( $preparedGroups );

// Prepare groups from the passed parameters.
foreach ( $this->params as $param )
{
	// Add parameter under its group!
	$preparedGroups[ $param->getDefinition()->getGroupId() ][ 'params' ][] = $param;
}

// Instantiate grouper.
// Only tab grouper is supported for now!
$grouperFactory = new CJT_Framework_View_Block_Parameter_Grouper_Factory();

$grouper = $grouperFactory->create( $this->form->groupType, $preparedGroups );

// Scripts
$plusBaseUri = CJTPlusPluginInterface::me()->getUrl();

$this->enqueueScript( 'jquery' );
$this->enqueueScript( 'jquery-serialize-object' );
$this->enqueueScript( 'cjtplus-ajaxserver', "{$plusBaseUri}Media/JavaScript/AjaxServer.js" );

$this->enqueueScript( 'cjt-simple-error-dialog', cssJSToolbox::getURI( 'framework:js:misc:simple-error-dialog:simple-error-dialog' ) . '.js' );
$this->enqueueScript( $this->getResName( 'Form' ), $this->getScriptUrl( 'Form' ) );

# Grouper Scripts
$grouperScripts = $grouper->enqueueScripts();

foreach ( $grouperScripts as $grouperScript )
{
	if ( strpos( $grouperScript, ':' ) !== FALSE )
	{
		$this->enqueueScript( md5( $grouperScript ), cssJSToolbox::getURI( $grouperScript ) . '.js' );
	}
	else
	{
		$this->enqueueScript( $grouperScript );
	}
}

# Styles
$this->enqueueStyle( 'cjt-forms', cssJSToolbox::getURI( 'framework:css:forms' ) . '.css' );
$this->enqueueStyle( 'cjt-simple-error-dialog', cssJSToolbox::getURI( 'framework:css:error-dialog' ) . '.css' );
$this->enqueueStyle( $this->getResName( 'Style' ), $this->getStyleUrl( 'Style' ) );

# Grouper styles
$grouperStyles = $grouper->enqueueStyles();

foreach ( $grouperStyles as $grouperStyle )
{
	if ( strpos( $grouperStyle, ':' ) !== FALSE )
	{
		$this->enqueueStyle( md5( $grouperStyle ), cssJSToolbox::getURI( $grouperStyle ) . '.css' );
	}
	else
	{
		$this->enqueueStyle( $grouperStyle );
	}
}

# Actions Route
$actionsRoute = array
(
	'getShortcode' => admin_url( 'admin-ajax.php?action=cjtplus-ajax-access-point-json&cjtpls-controller=BlockShortcodes&cjtpls-action=getShortcode' ),
);
?>
<html xmlns="http://www.w3.org/1999/xhtml">

	<head>
<?php do_action( 'admin_print_styles' ) ?>
<?php do_action( 'admin_print_scripts' ) ?>
	</head>

	<body>

		<div id="cjtoolbox_popup">
		  <form id="shortcode-params-form" class="cjt-form">
		  	<?php echo $grouper ?>
		  	<input type="button" id="btn-close" value="<?php echo CJTPLSHooks::_t( 'Close' ) ?>">
		  	<input type="button" id="btn-done" value="<?php echo CJTPLSHooks::_t( 'Done' ) ?>">
		  	<input type="hidden" name="blockId" value="<?php echo $blockId ?>">
				<?php if ( $packageInfo ) : ?>
					<span class="packag-info">
						<?php echo CJTPLSHooks::_t( 'By' ) ?>: <a target="_blank" href="<?php echo $packageInfo[ 'webSite' ] ?>"><?php echo $packageInfo[ 'author' ] ?></a>
					</span>
				<?php endif; ?>
		  </form>
		</div>

		<script type="text/javascript">
			// Apply TABs Plugin!
			jQuery( function( $ )
			{
				window.CJTPlusRO = new CJTMSAjaxServices( '<?php echo $this->securityToken ?>', <?php echo json_encode( $actionsRoute ); ?> );

				// Force form size.
				var size = { 'width' : '670px', 'height' : '600px' };
				parent.jQuery( '#TB_window' ).css( size );

				size.height -= 10;
				parent.jQuery( '#TB_iframeContent' ).css( size );

				// Tab size.
				$( '#cjt-grouper-tab-navigator' ).tabs().css( { height: '527px' } );

			} );
		</script>
<?php wp_print_footer_scripts(); ?>
	</body>
</html>