<?php


// Disallow direct access.
defined( 'ABSPATH' ) or die( 'Access denied');

# Scripts
$this->enqueueScript( 'jquery' );

$this->enqueueScript( 'cjt-ajax-services', CJTPlusPluginInterface::me()->getUrl() . 'Media/JavaScript/AjaxServer.js' );

$this->enqueueScript( $olJsHandle = $this->getResName( basename( __FILE__ ) ), $this->getScriptUrl( 'Templates/Permissions-Objects-List' ) );

# Localizae JavaScript
$this->localizeJS( $olJsHandle, 'L10nCJTPlusNetPemObjsList', array
(
	'resultLimit' => CJTPLSHooks::_t( 'Invalid result limits! Cannot be null!' ),
	'noResult' => CJTPLSHooks::_t( 'No result!!' ),
) );

$this->enqueueStyle( $this->getResName( basename( __FILE__ ) ), $this->getStyleUrl( 'Templates/Permissions-Objects-List' ) );

$this->routeActions = array
(
	'findObjectsList' => admin_url( "admin-ajax.php?action=cjtplus-ajax-access-point-json&cjtpls-controller=MSDashboardPanel&cjtpls-action=find{$objectsName}&cjtpls-template={$objectsName}List" )
);
?>
<html>
	<head>
<?php do_action( 'admin_print_styles' ) ?>
<?php do_action( 'admin_print_scripts' ) ?>
	</head>
	<body>
		<div class="cjtms-dashboardpanel-objects-list" id="cjtms-dashboardpanel-<?php echo strtolower( $resultSites ) ?>list" class="cjtms-popup-view">
			<ul class="cjtms-form-list">
				<li>
					<label for="find-objects-input"><?php echo $searchTitle ?></label><input type="text" name="query-object-name" value="" id="find-objects-input" placeholder="<?php echo CJTPLSHooks::_t( 'Type and press enter to search' ) ?>" />
				</li>
				<li>
					<label><?php echo CJTPLSHooks::_t( 'Result Count Limit' ) ?></label><input id="items-count-limiter" type="text" value="2000" />
				</li>
				<li>
					<ul id="queried-objects-result"></ul>
				</li>
				<li><input type="button" name="select-items" value="Select" /></li>
			</ul>
			
			<input type="hidden" name="securityToken" value="<?php echo $this->securityToken ?>" />
		</div>
<?php do_action( 'print_footer_scripts' ) ?>

	<script type="text/javascript">
		var cjtmsRoutes = <?php echo json_encode( $this->routeActions ) ?>;
		CJTMSQueryItemsList.setParams( <?php echo json_encode( array( 'resultListId' => $resultListId, 'itemName' => $itemName ) ) ?> )
	</script>
	
	</body>
</html>