<?php
/**
*
*/

/**
*
*/
class CJTPlusHooksCJTBlockAssignmentSettings
{

	/**
	* put your comment there...
	*
	* @param mixed $observer
	* @param mixed $content
	* @param mixed $name
	* @param mixed $file
	*/
	public function _loadBlockTemplate( $observer, $content, $name, $file )
	{

		switch ( $file )
		{

			// Send post types along with the request
			// It would act as single block property
			case 'tmpl/templates/assign-panel/default';

				global $wpdb;

				// Get Pin Types associated with current block
				$blockView = $observer->getTarget();
			  $blockId = $blockView->getBlockView()->getBlock()->id;

			  # Query block pin types
			  $pinTypesQuery = "SELECT * FROM {$wpdb->prefix}cjtoolbox_plus_block_pintype WHERE blockId = %d ORDER BY id ASC;";

			  $pinTypes = $wpdb->get_results( $wpdb->prepare( $pinTypesQuery, $blockId ), ARRAY_A );

				// Get
				ob_start();

				require 'BlockAssignmentSettings' . DIRECTORY_SEPARATOR . 'Tmpls' . DIRECTORY_SEPARATOR . 'BlockPinTypes.html.php';

				$content .= ob_get_clean();

			break;

		}

		return $content;
	}

	/**
	* put your comment there...
	*
	* @param mixed $obsever
	* @param mixed $content
	*/
	public function _loadGlobalComponents( $obsever, $content )
	{

		ob_start();

		require 'BlockAssignmentSettings' . DIRECTORY_SEPARATOR . 'Tmpls' . DIRECTORY_SEPARATOR . 'SettingsDialog.html.php';

		$content .= ob_get_clean();

		return $content;
	}

	/**
	* put your comment there...
	*
	* @param mixed $block
	* @param mixed $pins
	*/
	public function _onPreUpdateBlockPins( $block, $pins )
	{

		global $wpdb;

		$pinTypesTblName = "{$wpdb->prefix}cjtoolbox_plus_block_pintype";

		// Remove all currently inverted pins types
		$wpdb->delete( $pinTypesTblName,
				array( 'blockId' => $block[ 'id' ] ),
				array( '%d' )
			);

		// Add all submited pin types
		$pinTypes = ( isset( $block[ 'pinTypes' ] ) && $block[ 'pinTypes' ] ) ?
								explode( ',', trim( $block[ 'pinTypes' ] ) ) :
								array();

		// Only inverted types is submitted, non inverted is never submitted
		foreach ( $pinTypes as $pinType )
		{

			$pinRecord = array
			(
				'blockId' => $block[ 'id' ],
				'pinName' => trim( $pinType ),
				'invert' => 1
			);

			$wpdb->insert( $pinTypesTblName, $pinRecord, array( '%d', '%s', '%d' ) );
		}

	}

	/**
	* put your comment there...
	*
	* @param mixed $observer
	* @param mixed $styles
	*/
	public function _registerCSS( $observer, $styles )
	{
		//$styles[ ] = 'extension://css-javascript-toolbox-plus/Hooks/Modules/BlockAssignment:BlockAssignmentPanel';

		return $styles;
	}

	/**
	* put your comment there...
	*
	* @param mixed $observer
	* @param mixed $scripts
	*/
	public function _registerJS( $observer, $scripts )
	{
		$scripts[ ] = 'jquery-ui-accordion';
		$scripts[ ] = 'extension://css-javascript-toolbox-plus/Hooks/Modules/BlockAssignmentSettings:_BlockAssignmentSettings';

		return $scripts;
	}

	/**
	* put your comment there...
	*
	*/
	public function run()
	{

		// Its also required to register the new assigment types through JavaScript assignment panel
		CJTPlugin::on( 'CJTBlocksCjtBlockView.usescripts', array( & $this, '_registerJS' ) );

		// Block sylesheet for new Tag Navigator style
		CJTPlugin::on( 'CJTBlocksCjtBlockView.usestyles', array( & $this, '_registerCSS' ) );

		// Pin Type inputs
		CJTPlugin::on( 'CJTBlocksCjtBlockView.loadtemplate', array( & $this, '_loadBlockTemplate' ) );

		// output settings dialog (inline)
		CJTPlugin::on( 'CJTBlocksManagerView.loadglobalcomponents', array( & $this, '_loadGlobalComponents' ) );

		add_action( CJTPluggableHelper::FILTER_BLOCK_MODEL_PRE_UPDATE_BLOCK_PINS, array( & $this, '_onPreUpdateBlockPins' ), 10, 2 );
	}

}
