<?php
/**
*
*/

/**
*
*/
class CJTPlusHooksCJTBlockAssignmentTypes
{

	/**
	*
	*/
	const PINS_TAGS_CUSTOM_TAG = 0x4000;

	/**
	* put your comment there...
	*
	* @param mixed $tabs
	*/
	public function _addTagsTab( $tabs )
	{

		$advancedTab = array_pop( $tabs );

		$tabs[ 'post_tags' ] = array
		(
			'title' => 'Tags',
			'renderer' => 'objects-list',
			'type' => array
			(
				'type' => 'post_tag',
				'group' => 'post_tags',
				'targetType' => 'taxonomy'
			)
		);

		$tabs[ 'advanced' ] = $advancedTab;

		return $tabs;
	}

	/**
	* put your comment there...
	*
	* @param mixed $filter
	*/
	public function _couplingQueryFilter( $observer, $filter )
	{

		if ( ! is_admin() )
		{

			// Taqg page
			if ( is_tag() )
			{

				$filter->customPins[ ]	= array
				(

					'pin' => 'post_tags',

					'pins' => array( get_queried_object()->term_id ),

					'flag' => self::PINS_TAGS_CUSTOM_TAG,

				);

			}

			// Apply blocks assigned to post tags
			else if ( is_single() )
			{

				$tagsIds = wp_get_post_tags( $filter->currentObject->ID, array( 'fields' => 'ids' ) );

				if ( ! empty( $tagsIds ) )
				{

					$filter->params[ 'hasTags' ] = true;
					$filter->params[ 'tags' ] = $tagsIds;

					$filter->customPins[ ] = array
					(

						'pin' => 'post_tags',

						'pins' => $tagsIds,

						'flag' => self::PINS_TAGS_CUSTOM_TAG,

					);

				}

			}

		}


		return $filter;
	}

	/**
	* put your comment there...
	*
	* @param mixed $customPins
	*/
	public function _defineModelCustomPins( $customPins )
	{

		$customPins[ 'post_tags' ] = array
		(
			'pinValue' => self::PINS_TAGS_CUSTOM_TAG,
			'default' => array(),
		);

		return $customPins;
	}

	/**
	* put your comment there...
	*
	* @param mixed $observer
	* @param mixed $scripts
	*/
	public function _registerAssignTypesJS( $observer, $scripts )
	{
		$scripts[ ] = 'extension://css-javascript-toolbox-plus/Hooks/Modules/BlockAssignmentTypes:_BlockAssignmentPanel';

		return $scripts;
	}

	/**
	* put your comment there...
	*
	* @param mixed $observer
	* @param mixed $styles
	*/
	public function _registerStyleSheet( $observer, $styles )
	{
		$styles[ ] = 'extension://css-javascript-toolbox-plus/Hooks/Modules/BlockAssignmentTypes:BlockAssignmentPanel';

		return $styles;
	}

	/**
	* put your comment there...
	*
	*/
	public function run()
	{

		// Add Tags Tab to Block Assignmentpnel
		add_action( CJTPluggableHelper::FILTER_BLOCK_ASSIGN_PANEL_TABS , array( $this, '_addTagsTab' ) );

		// Its also required to register the new assigment types through JavaScript assignment panel
		CJTPlugin::on( 'CJTBlocksCjtBlockView.usescripts', array( & $this, '_registerAssignTypesJS' ) );

		// Block sylesheet for new Tag Navigator style
		CJTPlugin::on( 'CJTBlocksCjtBlockView.usestyles', array( & $this, '_registerStyleSheet' ) );

		// Block Model custom pins
		add_filter( CJTPluggableHelper::FILTER_BLOCK_MODEL_CUSTOM_PINS, array( $this, '_defineModelCustomPins' ) );

		// Tags assignment query filter
		CJTPlugin::on( 'CJTBlocksCouplingController.setfilters', array( $this, '_couplingQueryFilter' ) );

	}

}
