<?php
/**
* 
*/

/**
* 
*/
class CJTPlusHooksCJTBlockAssignmentNegative
{
	
	/**
	* put your comment there...
	* 
	* @var mixed
	*/
	private $negativeQuery = array();


	/**
	* put your comment there...
	* 
	* @param mixed $blocks
	* @param mixed $queryFilter
	*/
	public function _blocksQueue( $blocks, $queryFilter )
	{
		
		global $wpdb;
		
		$negativeQuery =& $this->negativeQuery;
		
		# Build negative query
		$negativeQueryStr = "SELECT {$negativeQuery[ 'columns' ]} FROM {$negativeQuery[ 'from' ]} WHERE ( {$negativeQuery[ 'where' ]} );";

		# Query negatively assigned blocks
		$negativeAssignedBlocks = $wpdb->get_results( $negativeQueryStr, OBJECT_K );
		
		# Merge blocks
		$blocks += $negativeAssignedBlocks;

		return $blocks;
	}
	
	/**
	* Force normal blocks query to query only
	* positive blocks, leave negative blocks to be processed
	* by this class 
	* 
	* @param mixed $query
	* @param mixed $queryFilter
	*/
	public function _queryBlocks( $queryObject, $queryFilter )
	{

        # FALSE blockQueue means query error (missing objectId)
        # Dont process until there is blockQueue 
        if ( ( $query =& $queryObject->getBlocksQuery() ) === FALSE )
        {
            return;
        }
        
		global $wpdb;
		
		# Initialize
		$negativeQParams = array();
		
		# Modify query based on the current pin	
		switch ( $queryFilter->currentCustomPin )
		{
			
			case CJTBlockModel::PINS_PAGES_CUSTOM_PAGE :
			
				# Query blocks those doesn't has page type inverted
				$positiveQParams[ 'targets' ][ ] = array
				(
					'pinType' => $queryFilter->currentObject->post_type,
				);
				
				# Negative query params to be build below
				$negativeQParams[ 'targets' ][ ] = array
				( 
					'pinName' => 'pages', 
					'pins' => array( $queryFilter->currentObject->ID ),
					'pinType' => 'page',
				);
				
			break;
			
			case CJTBlockModel::PINS_POSTS_CUSTOM_POST :
			
				# Allow only positive posts to be queries
				$positiveQParams[ 'targets' ][ ] = array
				(
					'pinType' => $queryFilter->currentObject->post_type,
				);
				
				# Negative query params to be build below
				$negativeQParams[ 'targets' ][ ] = array
				( 
					'pinName' => 'posts', 
					'pins' => array( $queryFilter->currentObject->ID ),
					'pinType' => $queryFilter->currentObject->post_type,
				);
				
				# Post categories
				if ( isset( $queryFilter->params[ 'hasCategories' ] ) )
				{
					
					$positiveQParams[ 'targets' ][ ] = array
					(
						'pinType' => 'category',
					);
					
					# Negative query params to be build below
					$negativeQParams[ 'targets' ][ ] = array
					( 
						'pinName' => 'categories', 
						'pins' => $queryFilter->params[ 'parentCategories' ],
						'pinType' => 'category',
					);
				}
				
				# Post Tags
				if ( isset( $queryFilter->params[ 'hasTags' ] ) )
				{
					
					$positiveQParams[ 'targets' ][ ] = array
					(
						'pinType' => 'post_tags',
					);
					
					# Negative query params to be build below
					$negativeQParams[ 'targets' ][ ] = array
					( 
						'pinName' => 'post_tags', 
						'pins' => $queryFilter->params[ 'tags' ],
						'pinType' => 'post_tags',
					);
				}
				
			break;

			case CJTBlockModel::PINS_CATEGORIES_CUSTOM_CATEGORY :
				
				# Query only positive category blocks if if it has parent categories
				$positiveQParams[ 'targets' ][ ] = array
				(
					'pinType' => 'category',
				);
				
				# Negative query params to be build below
				$negativeQParams[ 'targets' ][ ] = array
				( 
					'pinName' => 'categories', 
					'pins' => array( $queryFilter->currentObject->ID ),
					'pinType' => 'category',
				);
				
			break;
			
			case CJTPlusHooksCJTBlockAssignmentTypes::PINS_TAGS_CUSTOM_TAG :
				
				# Query only positive category blocks if if it has parent categories
				$positiveQParams[ 'targets' ][ ] = array
				(
					'pinType' => 'post_tag',
				);
				
				# Negative query params to be build below
				$negativeQParams[ 'targets' ][ ] = array
				( 
					'pinName' => 'post_tags', 
					'pins' => array( $queryFilter->currentObject->ID ),
					'pinType' => 'post_tag',
				);
				
			break;
			
			
			default :
			
				// Don't modify query if the case is not being procesed by 
				// Plus Negative assignment (all authors, all archvies, etc... )
				return;
				
			break;
		}

		$queryCustomPins =& $queryObject->getCustomPins();
		
		# Restrict Positive assignment
		foreach ( $positiveQParams[ 'targets' ] as $targetIndex => $target )
		{
			
			$pinTypesTbleName = "pinTypes{$targetIndex}";
			
			# From Tables
			$query[ 'from' ] .= " LEFT JOIN {$wpdb->prefix}cjtoolbox_plus_block_pintype {$pinTypesTbleName} ON blocks.id = {$pinTypesTbleName}.blockId AND {$pinTypesTbleName}.pinName = '{$positiveQParams[ 'targets' ][ $targetIndex ][ 'pinType' ]}' AND {$pinTypesTbleName}.invert = 1";
			
			# Custom pins WHERE Filters
			$queryCustomPins[ $targetIndex ] = "( {$queryCustomPins[ $targetIndex ]} AND ( ( {$pinTypesTbleName}.invert IS NULL ) AND ( {$pinTypesTbleName}.pinName IS NULL ) ) )";
			
		}
		
		### Negative blocks query columns ###
		$negativeQuery[ 'columns' ] = array
		( 
			'blocks.id',
			'blocks.owner',
			'blocks.name',
			'blocks.pinPoint',
			'blocks.location',
			'blocks.links',
			'blocks.expressions',
			'0 as blocksGroup',
		);
		
		# Build FROM and WHERE clauses
		$negativeQuery[ 'from' ][ ] = "{$wpdb->prefix}cjtoolbox_blocks blocks";
		$negativeQuery[ 'where' ][ 'common' ] = '( ( `backupId` IS NULL ) AND ( `state` = "active" ) )';
		
		foreach ( $negativeQParams[ 'targets' ] as $index => $target )
		{

			# Target FROM
			$pinTableAlias = "pins{$index}";

			$targetPins = implode( ',', $target[ 'pins' ] );

			$negativeQuery[ 'from' ][ ] = "LEFT JOIN {$wpdb->prefix}cjtoolbox_block_pins {$pinTableAlias} ON blocks.id = {$pinTableAlias}.blockId AND {$pinTableAlias}.pin='{$target[ 'pinName' ]}' AND {$pinTableAlias}.value IN( {$targetPins} ) ";
			
			# Target WHERE
			$negativeQuery[ 'where' ][ 'pinType' ][ ] = "( pt.pinName = '{$target[ 'pinType' ]}' AND pt.invert = 1  )";
			$negativeQuery[ 'where' ][ 'inverted' ][ ] = "(  ( {$pinTableAlias}.pin IS NULL ) AND ( {$pinTableAlias}.value IS NULL ) )";
		}
		
		$negativeQuery[ 'where' ][ 'pinType' ] = '( ' . implode( ' OR ', $negativeQuery[ 'where' ][ 'pinType' ] ) . ' )';
		$negativeQuery[ 'where' ][ 'inverted' ] = '( ' . implode( ' AND ', $negativeQuery[ 'where' ][ 'inverted' ] ) . ' )';
		
		$negativeQuery[ 'from' ][ ] = "LEFT JOIN `{$wpdb->prefix}cjtoolbox_plus_block_pintype` pt ON blocks.`id` = pt.`blockId`";
		
		
		# Build negative query
		$negativeQuery[ 'columns' ] = implode( ',', $negativeQuery[ 'columns' ] );
		$negativeQuery[ 'from' ] = implode( ' ', $negativeQuery[ 'from' ] );
		$negativeQuery[ 'where' ] = implode( ' AND ', $negativeQuery[ 'where' ] );
		
		$this->negativeQuery = $negativeQuery;
		
		# Query negative blocks
		add_filter( CJTPluggableHelper::FILTER_BLOCKS_COUPLING_MODEL_BLOCKS_QUEUE, array( $this, '_blocksQueue' ), 10, 2 );
	}

	/**
	* put your comment there...
	* 
	*/
	public function run()
	{
		
		// Negative assignment
		add_action( CJTPluggableHelper::ACTION_BLOCK_QUERY_BLOCKS, array( $this, '_queryBlocks' ), 10, 2 );
		
	}
	
}
