<?php
/**
* 
*/


/**
* 
*/
class CJTPlusHooksBlocksCouplingHookAttacher {
    
    /**
    * 
    */
    const GROUP = 'cjt-plus';
    
    /**
    * 
    * 
    * @var mixed
    */
    private $attacher;

    /**
    * Output blocks Before and After Filter content
    * 
    */
    public function _onoutputblocksaftercontent($content) {

        $coupling =& CJTBlocksCouplingController::theInstance();
        
        $content = "{$content}{$coupling->blocks['code']['after_the_content']}";
        
        return $content;
    }
    
    /**
    * Output blocks Before and After Filter content
    * 
    */
    public function _onoutputblocksbeforecontent($content) {
        
        $coupling =& CJTBlocksCouplingController::theInstance();
        
        $content = "{$coupling->blocks['code']['before_the_content']}{$content}";
        
        return $content;
    }

    /**
    * Output blocks Before and After Filter content
    * 
    */
    public function _onoutputblocksafterexcerpt($excerpt) {

        $coupling =& CJTBlocksCouplingController::theInstance();
        
        $excerpt = "{$excerpt}{$coupling->blocks['code']['after_the_excerpt']}";
        
        return $excerpt;
    }
    
    /**
    * Output blocks Before and After Filter content
    * 
    */
    public function _onoutputblocksbeforeexcerpt($excerpt) {

        $coupling =& CJTBlocksCouplingController::theInstance();
        
        $excerpt = "{$coupling->blocks['code']['before_the_excerpt']}{$excerpt}";
        
        return $excerpt;
    }

    /**
    * put your comment there...
    * 
    * @param CJTBlocksCouplingHookAttacher $attacher
    */
    public function _oninitcouplingattacher($attacher) {
        
        // Get type handler to call $this object instead of the hook attacher instance
        $this->attacher = $attacher;
        $attacher->typeHandler = $this;
        
        // Add the hooks to the attacher
        $moreHooks = array(
        
            // Attached hooks are (statically) attached to either backend or frontend
            'attached' => array(
            
                /* Database location map name */    /* Wordpress Hook name */ 
                'wp_body_open' => array(
                    'name' => 'wp_body_open',
                    'handler' => $this->attacher->callback,
                    'title' => CJTPLSHooks::_t('Body Open'),
                    'text' =>  CJTPLSHooks::_t('Put Block code right after the <body> HTML tag'),
                    'group' => self::GROUP,
                ),
                'before_the_content'  => array(
                    'name' => 'the_content',
                    'handler' => array($this, '_onoutputblocksbeforecontent'),
                    'title' => CJTPLSHooks::_t('Before Post Content'),
                    'text' => CJTPLSHooks::_t('Put Block code before Post Content'),
                    'group' => self::GROUP,
                ),
                'after_the_content'  => array(
                    'name' => 'the_content',
                    'handler' => array($this, '_onoutputblocksaftercontent'),
                    'title' => CJTPLSHooks::_t('After Post Content'),
                    'text' => CJTPLSHooks::_t('Put Block code After Post Content'),
                    'group' => self::GROUP,
                ),
                'before_the_excerpt'  => array(
                    'name' => 'the_excerpt',
                    'handler' => array($this, '_onoutputblocksbeforeexcerpt'),
                    'title' => CJTPLSHooks::_t('Before Post Excerpt'),
                    'text' => CJTPLSHooks::_t('Put Block code just before post excerpt'),
                    'group' => self::GROUP,
                ),
                'after_the_excerpt'  => array(
                    'name' => 'the_excerpt',
                    'handler' => array($this, '_onoutputblocksafterexcerpt'),
                    'title' => CJTPLSHooks::_t('After Post Excerpt'),
                    'text' => CJTPLSHooks::_t('Put Block code after post excerpt'),
                    'group' => self::GROUP,
                ),
                'loop_start'   => array(
                    'name' => 'loop_start',
                    'handler' => $this->attacher->callback,
                    'title' => CJTPLSHooks::_t('Before Posts List'),
                    'text' => CJTPLSHooks::_t('Put Block code right before posts list or before the post in case the posts query result is a a single post'),
                    'group' => self::GROUP,
                ),
                'loop_end'     => array(
                    'name' => 'loop_end',
                    'handler' => $this->attacher->callback,
                    'title' => CJTPLSHooks::_t('After Posts List'),
                    'text' => CJTPLSHooks::_t('Put Block code right after posts list or after the post in case the posts query result is a a single post'),
                    'group' => self::GROUP,
                ),
                'the_post'     => array(
                    'name' => 'the_post',
                    'handler' => $this->attacher->callback,
                    'title' => CJTPLSHooks::_t('Before Post'),
                    'text' => CJTPLSHooks::_t('Put Block code right before the post'),
                    'group' => self::GROUP,
                ),
            ),
        );
        
        $attacher->filters += $moreHooks;
    }
    
    /**
    * 
    * Just return All Attached Hook names
    * 
    * @param mixed $filters
    * @return CJTBlocksCouplingHookAttacher
    */
    public function & genAttachedHooks($filters) {
        
        $this->attacher->genHooks($filters);
        
        return $this;
    }
    
    /**
    * Generate unattached hook names by adding either (wp_ or admin_ prefix to the hook name(s)
    * 
    * @param mixed $filters
    * @return CJTBlocksCouplingHookAttacher
    */
    public function genUnattachedHooks($filters) {
        
        $this->attacher->genUnattachedHooks($filters);
    }
    
    /**
    * put your comment there...
    * 
    */
    public function run() {
    
        add_action(CJTPluggableHelper::ACTION_BLOCKS_COUPLING_INIT_ATTACHER, array($this, '_oninitcouplingattacher'));
        
    }
    
}