<?php
/**
 *
 */

// Class Autoloader
require_once plugin_dir_path(__FILE__) . DIRECTORY_SEPARATOR . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php';

/**
 *
 */
class CJTPlusPluginInterface extends CJTServicesPluginBase
{

	/**
	 * put your comment there...
	 *
	 * @var CJTPlusPluginInterface
	 */
	protected static $instance;

	/**
	 * put your comment there...
	 *
	 */
	protected function __construct()
	{

		# Load config
		$config = require 'Config' . DIRECTORY_SEPARATOR . 'Config.php';

		parent::__construct(__FILE__, $config);

	}

	/**
	 * put your comment there...
	 *
	 */
	protected function initializeServices()
	{

		try {

			// Run installed, dont process if
			if (! CJTPlusInstaller::run()) {
				return;
			}

		} catch (Exception $exception) {

			// ----
			add_action('admin_notices',

				/**
				 * put your comment there...
				 *
				 */
				function () {

					require __DIR__ . DIRECTORY_SEPARATOR . 'Installer' .
						DIRECTORY_SEPARATOR . 'Notice.html.php';
				}

			);

		}

		# Hooking
		CJTPLSHooks::run();

		# Dashbaard Pages and AJAX End Points
		if (is_admin()) {

			$this->loadServices(

				new CJTPLSServiceNetworkDashboard(),

				new CJTPLSAjaxService()

			);

		}

	}

	/**
	 * put your comment there...
	 *
	 */
	public static function &me()
	{
		return self::$instance;
	}

	/**
	 * put your comment there...
	 *
	 */
	public static function &plug()
	{

		if (! self::$instance) {
			self::$instance = new CJTPlusPluginInterface();

			self::$instance->initializeServices();
		}

		return self::$instance;
	}

}
