<?php
/**
* 
*/

// Disallow direct access.
defined('ABSPATH') or die("Access denied");

/**
* 
*/
class CJTPlus {

	/**
	* put your comment there...
	* 
	* @var mixed
	*/
	protected $extensions = array();
	
	/**
	* put your comment there...
	* 
	* @var mixed
	*/
	protected $hooksMap = array();

	/**
	* put your comment there...
	* 
	*/
	public function __construct() 
	{
    
		# Load bnubled extensions
		$this->loadExtensions();
		
	}

	/** 
	* put your comment there...
	* 
	*/
	public function & getExtensions() 
	{
		return $this->extensions;
	}
	
	/**
	* put your comment there...
	* 
	* @param mixed $observer
	* @param mixed $filterParam
	*/
	public function getInvolved( $observer, $filterParam ) 
	{
		
		$subject = $observer->getSubject();              	
		$target = $subject->getTarget();
		
		# Get hook name exactly as defined in the Devloper extension XML file
		$hookName = ( is_string( $target ) ? $target : get_class( $target) ) . '.' . $subject->getName();
		
        # Load New Plugins Interface only one time 
        # as this method will be called on every hooked event defined
        # in the xml document
        static $isPlusPluginInterfaceLoaded = false;
        
        if (!$isPlusPluginInterfaceLoaded) {
            
            require_once 'PlusPluginInterface.class.php';
            
            CJTPlusPluginInterface::plug();            
            
            $isPlusPluginInterfaceLoaded = true;
        }
            
		# Redirect the call to all extensions associated with current hook name
		$hookExtensions = $this->getMappedExtensions( $hookName );
		
		foreach ( $hookExtensions as $extension ) 
		{
			# Invoke extension callback
		 	$filterParam = call_user_func( $extension['eventHandler'], $observer, $filterParam );
		}
		
		return $filterParam;
	}   

	/**
	* put your comment there...
	* 
	* @param mixed $hookName
	*/
	public function getMappedExtensions($hookName) 
	{
		return $this->hooksMap[$hookName];
	}
	
	/**
	* put your comment there...
	* 
	*/
	protected function & loadExtensions() 
	{
		
		$extHandlerMethodName = 'getInvolved';
		$pluginsDir = str_replace( '/', DIRECTORY_SEPARATOR, WP_PLUGIN_DIR ) . DIRECTORY_SEPARATOR;
		
		# Load Bundled extensions plugin file
		foreach ( new DirectoryIterator( __DIR__ . DIRECTORY_SEPARATOR . 'extensions' ) as $cjtDevExtension ) 
		{
			# Every directory is an extension
			if ( $cjtDevExtension->isDir() && ! $cjtDevExtension->isDot() ) 
			{
				
				$pluginSlug = $cjtDevExtension->getFilename();
				
				# Load single extension core file exactly as Wordpress Loading Plugins
				$extension = array
				(
					'relPath' => str_replace( $pluginsDir, '', $cjtDevExtension->getPathname() ),
					'slug' => $pluginSlug,
					'directory' => $cjtDevExtension->getPathname(),
					'file' => ( $cjtDevExtension->getPathname() . DIRECTORY_SEPARATOR . "{$pluginSlug}.php" ),
					'baseClassFile' => ( $cjtDevExtension->getPathname() . DIRECTORY_SEPARATOR . "{$pluginSlug}.class.php" ),
					'xmlFile' => ( $cjtDevExtension->getPathname() . DIRECTORY_SEPARATOR . "{$pluginSlug}.xml" ),
				);
				
				# Load extension main/base file and class file
				require $extension['file'];
				require $extension['baseClassFile'];
				
				# Load XML file
				$extension['meta'] = new SimpleXMLElement( file_get_contents( $extension['xmlFile'] ) );
				
				# If XML is for versions older 1.0, use static method call otherwise, use object instance
				$extAttributes = $extension['meta']->attributes();
				$extension['class'] = ( string ) $extAttributes->class;
				
				# Instantiate extension object
				$extension['object'] = new $extension['class']( $extension );
				$extension['eventHandler'] = array( $extension['object'], $extHandlerMethodName );
				
				$this->extensions[$pluginSlug] = $extension;
				
				# Get all event associated with extension,
				# map extension reference by using hook names
				foreach ( $extension['meta']->getInvolved->event as $eventEle ) 
				{
					# Map extension to all hook defined inside its XML file
					# so that it would be simple to dispatch the call
					# for all elements associated with the event type
					$this->hooksMap[ ( ( string ) $eventEle->attributes()->type ) ][ ] = $extension;
				}
				
			}
		}
		
		return $this;
	}   

}