<?php
/**
*
*/

/**
*
*/
class CJTEBWL_Controllers_Widget extends WP_Widget {

	/**
	* put your comment there...
	*
	* @var mixed
	*/
	protected $blocksMap;

	/**
	* put your comment there...
	*
	* @var mixed
	*/
	protected $model;

	/**
	* put your comment there...
	*
	* @var mixed
	*/
	protected $view;

	/**
	* put your comment there...
	*
	*/
	public function __construct()
	{
		// Creating view.
		$this->view = new CJTEBWL_Views_Widget_View();

		// Instantiate the parent object
		parent::__construct (get_class( $this ), CJTPLSHooks::_t( 'CJT Block Widget Linker' ) );

		// Map block id that is linked to block widget linker instances (all of them)
		$instances = get_option( $this->option_name, array() );

		foreach ($instances as $wId => $widgetInstance)
		{
			# Only widgets with block assigned
			if (!isset($widgetInstance[ 'blockid' ]) || !$widgetInstance[ 'blockid' ])
			{
				continue;
			}

			// Add to map if not being added
			if ( ! isset($this->blocksMap[ $widgetInstance[ 'blockid' ] ] ) )
			{
				// Mark as not matched by default until matched by coupling onblockmatched event
				$this->blocksMap[ $widgetInstance[ 'blockid' ] ] = array
				(
					'matched' => false,
					'lockglobalassignment' => $widgetInstance[ 'lockglobalassignment' ]
					);
			}
			else
			{
				// Once a single Widget has Prevent Global checkbox checked it would prevent this block from output globally
				// used by widget only
				$this->blocksMap[ $widgetInstance[ 'blockid' ] ][ 'lockglobalassignment' ] |= $widgetInstance[ 'lockglobalassignment' ];
			}
		}

		// Listen for matched blocks
		CJTBlocksCouplingController::theInstance()->onblockmatched = array( $this, 'onblockmatched' );

	}

	/**
	* put your comment there...
	*
	* @param mixed $block
	*/
	public function onblockmatched($observer, $block) {
		// Enter into filter only if current block associated with any widget instance
		if (isset($this->blocksMap[$block->id])) {
			# Block map reference
			$blockMap =& $this->blocksMap[$block->id];
			# Mark as matched block so that widget knows that5 the block associated with
			# it has passed the assignment panel matching algorithem
			$blockMap['matched'] = true;
            $blockMap['block_name'] = $block->name; // <--- CODE ADDED BY RBJ
			# Prevent from globally outputted if lockglobalassignment has been set
			if ($blockMap['lockglobalassignment']) {
				# Don't include in the outputted blocks list
				$block = null;
			}
		}
		# Returns block or
		return $block;
	}

	/**
	* put your comment there...
	*
	* @param mixed $args
	* @param mixed $instance
	*/
	function widget( $args, $instance ) {
		// Process associated block shortcode only if the passed the assignmet
		// panel filter
		if (isset($this->blocksMap[$instance['blockid']]) && ($this->blocksMap[$instance['blockid']]['matched'] === true)) {
			// CODE ADDED BY RBJ -- START
            $instance['block_name'] = $this->blocksMap[$instance['blockid']]['block_name'];
            $theShortCode = do_shortcode($instance['shortcodesource']);
            $theShortCode = preg_replace('/<!--[\s\S]+?-->/', '', $theShortCode);
            $theShortCode = str_replace("\n", "", $theShortCode);

            echo "\n\n<!-- CJT Widget Block ($instance[blockid]) - $instance[block_name] - START -->\n$theShortCode\n<!-- CJT Widget Block ($instance[blockid]) - $instance[block_name] - END -->\n\n";
            // CODE ADDED BY RBJ -- END
		}
	}

	/**
	* put your comment there...
	*
	* @param mixed $new_instance
	* @param mixed $old_instance
	* @return array
	*/
	function update( $new_instance, $old_instance ) {
		// Create option
		$instance = array();
		// Add options
		$instance['blockid'] = stripcslashes( $_POST['blockid'] );
		$instance['shortcodesource'] = stripcslashes($_POST['shortcodesource']);
		$instance['lockglobalassignment'] = (int) $_POST['lockglobalassignment'];
		// Save widget options
		return $instance;
	}

  /**
  * put your comment there...
  *
  * @param mixed $instance
  */
	function form( $instance ) {
		# Create Model.
		$this->model = CJTModel::getInstance('blocks');
		# Push model into view
		$this->view->setModel($this->model);
		# Default parameters
		if (!$instance) {
			$instance['blockid'] = null;
			$instance['lockglobalassignment'] = 1;
			$instance['shortcodesource'] = '';
		}
		# Init view Parameters
		$params = array('widgetPrototypeId' => $this->id_base,
										'widgetId' => $this->id,
										'instance' => $instance);
		# Getting output
		echo $this->view->getWidgetTemplate('form', $params);
	}

}
