/**
* 
*/
var CJTEEditorThemes;

/**
* 
*/
(function($) {
	
	/**
	* put your comment there...
	* 
	* @type T_JS_FUNCTION
	*/
	CJTEEditorThemes = new function() {
	  // Initialize.
	  this.block = null;
		// Create Unattached Themes list 
		// to be used accross all the blocks.
		var theme = null;
	  var themesUIListContainer = $('<div class="popup-menu editor-themes-list"></div>').css({display: 'none'});
	  var themesUIList = $('<ul></ul>').appendTo(themesUIListContainer);
	  var themesAnchorsMap = {}, themes = [
   		'ambiance',
   		'chaos', 
   		'chrome', 
   		'clouds', 
   		'clouds_midnight', 
   		'cobalt', 
   		'crimson_editor', 
   		'dawn', 
   		'dreamweaver', 
   		'eclipse', 
   		'github', 
   		'idle_fingers',
   		'katzenmilch',
   		'kr',
   		'kuroir',
   		'merbivore',
   		'merbivore_soft',
   		'mono_industrial',
   		'monokai',
   		'pastel_on_dark',
   		'solarized_dark',
   		'solarized_light',
   		'terminal',
   		'textmate',
   		'tomorrow',
   		'tomorrow_night',
   		'tomorrow_night_blue',
   		'tomorrow_night_bright',
   		'tomorrow_night_eighties',
   		'twilight',
   		'vibrant_ink',
   		'xcode'
	  ];
	  
	  /**
	  * put your comment there...
	  * 
	  * @param event
	  */
	  var _onswitchtheme = function(event) {
   		// Get theme name associated with the link.
   		var editorTheme = $(event.target).data('ace-theme-key');
   		// Save theme.
   		CJTEEditorThemes.block.block.set('editorTheme', editorTheme);
   		// Select menu theme.
   		CJTEEditorThemes.selectMenuTheme();
   		// Set editor theme.
   		CJTEEditorThemes.setEditorTheme();
   		// Link Inactive.
   		return false;
	  };

	  /**
	  * put your comment there...
	  * 
	  * @param button
	  */
	  var _oncallback = function( targetList, button )
	  {
   		// Associate list to current activate block.
   		CJTEEditorThemes.block = this;
   		
   		// Select default.
   		CJTEEditorThemes.selectMenuTheme();
   		
   		// ACE Themes list style.
			CJTEEditorThemes.applyTheme( this );
			
   		// Add the list just after the button.
   		button.jButton.after( targetList );
   		
	  };
	  	  
	  /**
	  * 
	  */
	  this.applyTheme = function( block ) 
	  {
			// Apply theme to Themes list.
			themesUIList.css( 'background-color', block.theme.backgroundColor );
			
			// Apply to block components
			CJTBlockCodeFileView.applyTheme( block );
			
            // Hooks Dropdown theme
            block.block.box.find("  .hooks-dropdown, \
                                    .hooks-dropdown .hooks-dropdown-list, \
                                    .cjt-toolbox .popup-menu, \
                                     input:text").css(
            {
                'background-color'  : block.theme.backgroundColor
            });
            
            block.block.box.find('input:text').css({
                color : block.theme.color
            });
                        
			// Fire apply theme event
			if ( block.onapplytheme !== undefined ) {
				block.onapplytheme( block );
			}
			
            if (CJTToolBox.forms.templatesLookupForm[block.block.get('id')] !== undefined) {
                CJTToolBox.forms.templatesLookupForm[block.block.get('id')].form.refresh();
            }
            
			block.block.box.trigger( 'cjtblockthemechanged', block );
			
	  };

	  /**
	  * 
	  */
	  this.getEditorTheme = function() {
			return this.block.block.get('editorTheme', 'chrome');
	  };

		/**
		* 
		*/
		this.getType = function(block) {
			// Associate block for initialize.
			// block would be changed again everytime
			// a block is initialized
			// or menu is selected.
			this.block = block;
			// Bind to themeLoaded event.
			var model = block.block;
			var editor = model.aceEditor;
			editor.renderer.addEventListener('themeLoaded', $.proxy(
				function() {
					var jEditor = $(editor.container);
					// Set theme colors.
					block.theme.backgroundColor = jEditor.css('background-color');
					block.theme.color = jEditor.css('color'); 
                    block.theme.altTextColor = jEditor.find('.ace_layer .ace_cursor').css('color');
                    
					// Apply Theme to block element.
					model.box.css('background-color', block.theme.backgroundColor);
					block.block.box.find('.hndle').css('color', block.theme.color);
					// ACE Themes list theme.
					this.applyTheme(block);
				}, this)
			);
			// Set default theme.
			this.setEditorTheme();
			// Type object.
			return {
									
				// Callback
				callback : _oncallback,
				
				/**
				* put your comment there...
				* 
				* @type String
				*/
				type : 'Popup',
				
				/**
				* 
				*/
				params : {
					// Parameters for PopupList type button.
					_type : {
						targetElement : themesUIListContainer,
						targetElementObject : true
					}
				}
			}
		};

		/**
		* 
		*/
		this.selectMenuTheme = function() {
			// Get editor theme.
			var editorTheme = this.getEditorTheme();
   		// Clear any previously selected item.
   		themesUIList.find('a').removeClass('active');
   		// Select default.
   		themesAnchorsMap[editorTheme].addClass('active');
		};

		/**
		* 
		*/
		this.setEditorTheme = function() {
			// INitialize.
			var model = this.block.block;
			var editor = model.aceEditor;
   		// Set editor theme.                                 
   		// TODO: Full theme name might be saved somewhere!
   		var themePath = 'ace/theme/' + this.getEditorTheme();
			// Change theme.
			editor.setTheme(themePath);
		};
    
		// Get ajax url.
		var ajaxURL = (window['ajaxurl'] != undefined) ?
									 window['ajaxurl'] : // For Blocks
									 window.top.CJTBlocksPage.server.ajaxURL; // For Template
		// Get snippets Url.
		var themesUrl = ajaxURL.replace('wp-admin/admin-ajax.php', 'wp-content/plugins/css-javascript-toolbox-plus/extensions/cjte-editor-themes/includes/ace/themes/');
		
	  // Build list.
	  $.each(themes, $.proxy(
   		function(index, themeName) {
   			// Add item to list.
   			var listItem = $('<li></li>').appendTo(themesUIList);
   			// Define ACE Module Url for every theme
   			ace.config.setModuleUrl(('ace/theme/' + themeName), (themesUrl + ('theme-' + themeName + '.js')));
   			// Create link + replace name with the anchor.
   			themesAnchorsMap[themeName] = $('<a href="#">' + CJTEETHM_Includes_ViewThemesI18N[('ace_theme-' + themeName)] + '</a>').appendTo(listItem)
   			// Class.
   			.addClass('cjt-link')
   			// Store theme key.
   			.data('ace-theme-key', themeName)
   			// Handle item click.
   			.click(_onswitchtheme);
   		}, this)
	  );
    
	};

})(jQuery);