/**
*
*/

/**
*
*/
(function($) {

    /**
    * put your comment there...
    *
    */
    var CJTBlockPluginBaseEditorToolbox = CJTBlockPluginBase;

    /**
    * put your comment there...
    *
    */
    CJTBlockPluginBase = function() {};

    // Extend CJTBlockPluginBaseCAC prototype!
    CJTBlockPluginBase.prototype = new CJTBlockPluginBaseEditorToolbox();

    // Override load method!
    CJTBlockPluginBase.prototype.CJTeloadEditorToolbox = CJTBlockPluginBase.prototype.load;

    /**
    * put your comment there...
    *
    */
    CJTBlockPluginBase.prototype.load = function() {
        
        // Load Block Base!
        this.CJTeloadEditorToolbox();
        
        // Block Menu
        this.block.aceEditor.setOptions(this.block.get('aceEditorMenuSettings', {showPrintMargin : false}));
        
        this.menu = new CJTBlockMenu(this);
        
        // Applying theme event for menu to take new style
        var prevApplyThemeEvent = this.onapplytheme;
        
        this.onapplytheme = function(block) {
            
            // Change theme
            this.menu.applyTheme(block);
            
            // Chain
            if(prevApplyThemeEvent) {
                
                prevApplyThemeEvent(block);
                
            }
        };
        
        var tbIconsGroup = this.block.box.find('.editor-toolbox .icons-group');
        
        var fontsPopupMenu = $('<div class="popup-menu fonts"></div>').appendTo(tbIconsGroup);
        
        // Define buttons
        var buttons = {};
        
        // Add Assignmen panel toggeler only if not using METABOX level block
        if (CJTBlocksPage.metaboxBlockToolbox === undefined) {
            
            buttons['toggle-objects-panel'] = {callback : this._cjteetb_on_toggleobjectspanel};
            
        }
        else {
            
            buttons['preview'] = {callback : this._cjteetb_on_metaboxpreview};
        }
                
        // Define all other buttons
        buttons['fullscreen'] = {callback : this._cjteetb_on_fullscreen};
        buttons['beautify'] = {callback : this._cjteetb_on_beautify};
        buttons['minify'] = {callback : this._cjteetb_on_minify};

        buttons['fonts'] = {
            type : 'Popup',
            params : {
                _type : {
                    targetElement : '.fonts',
                    setTargetPosition : false
                }
            }
        };
        buttons['font-large'] = {
            callback : this._cjteetb_on_fontsize,
            params : {direction: 1},
            parent : fontsPopupMenu,
            cssClass : 'cjt-tb-text-link'
        };
        buttons['font-small'] = {
            callback : this._cjteetb_on_fontsize,
            params : {direction: -1},
            parent : fontsPopupMenu,
            cssClass : 'cjt-tb-text-link'
        };
        buttons['reset-font'] = {
            callback : this._cjteetb_on_fontsize,
            params : {reset : true},
            parent : fontsPopupMenu,
            cssClass : 'cjt-tb-text-link'
        };
        buttons['save-editor-options'] = {callback : this._cjteetb_on_saveeditoroptions};
        
        // Add buttons
        var buttonParent, sanitizedName, linkText;
        
        $.each(buttons, $.proxy(
        
            function(name, calbackObject) 
            {
                
                sanitizedName = name.replace(/\-/g, '_');
                
                buttonParent =  calbackObject['parent'] === undefined ?
                                tbIconsGroup :
                                calbackObject['parent'];
                
                cssClass =      calbackObject['cssClass'] !== undefined ? 
                                calbackObject['cssClass'] :
                                '';
                
                linkText =      CJTEETB_Views_Block_ViewToolboxI18N[sanitizedName + '_text'] ?
                                CJTEETB_Views_Block_ViewToolboxI18N[sanitizedName + '_text'] :
                                '';
                
                // Add Button markup
                $('<a href="#" class="cjt-tb-link cjttbl-' + name + '"></a>').appendTo(buttonParent)
                
                .text(linkText)
                  
                .prop('title', CJTEETB_Views_Block_ViewToolboxI18N[sanitizedName])
                
                .addClass(cssClass);
                
                // Create Toolbox button object
                this.editorToolbox.add(name, calbackObject);
                
            }, this)
            
        );
        
        // Fonts Popup menu
        fontsPopupMenu.hide();
        
        // Insert Menu right after fullscreen button
        this.editorToolbox.buttons['fullscreen'].jButton.after(this.menu.menu);
        
        // Close it if it were closed.
        if (CJTBlocksPage.metaboxBlockToolbox === undefined) {
            
            this._cjteetb_on_toggleobjectspanel({target : $('.toggle-objects-panel')}, this.block.get('pagesPanelToggleState', ''));
            
        }
        
    };

    // CODE ADDED BY RBJ -- START
    CJTBlockPluginBase.prototype._cjteetb_on_beautify = function() {
        let ace = this.block.aceEditor;
        var editor = $(this.block.aceEditor.container);
        var edtSession =  this.block.aceEditor.getSession();
        var code = edtSession.getValue();
        var edtLang = this.block.get('editorLang');
        var beautifyTypeMap = {
            'javascript' : 'js',
            'css' : 'css',
            'html' : 'html'
        };
        switch (edtLang) {
            case 'javascript':
            case 'css':
            case 'html':
                var beautfierFunc = beautifyTypeMap[edtLang] + '_beautify';
                code = window[beautfierFunc](code);
                ace.$blockScrolling = Infinity;
                edtSession.setValue(code);

            break;
            // No Beautifying for PHP
            case 'php':
                return;
            break;
        }
    }

    CJTBlockPluginBase.prototype._cjteetb_on_minify = function() {
        let ace = this.block.aceEditor;
        var editor = $(this.block.aceEditor.container);
        var edtSession = this.block.aceEditor.getSession();
        var code = edtSession.getValue();
        var edtLang = this.block.get('editorLang');
        ace.$blockScrolling = Infinity;

        CJTServer.send('blocks', 'minify', {
            cjtajaxmodule : 'ECMEHD',
            editLang : edtLang,
            content :  code
        }, 'post').done(function(minifiedCode) {
            edtSession.setValue(minifiedCode);
        }
        )
    }
    // CODE ADDED BY RBJ -- END

    /**
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_clearblock = function() {
        var aceEditor = this.block.aceEditor;
        //Directly clear using setValue('') won't save the history!
        // Select all text.
        aceEditor.selectAll();
        // Replace content with empty string!
        aceEditor.getSession().replace(aceEditor.getSelectionRange(), '');
        aceEditor.focus();
    }

    /**
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_fontsize = function(event, params) {
		var blockModel = this.block;
        var editor = $(this.block.aceEditor.container);
        // Reset font size to default.
        if (params.reset) {
            // Remove fontSize and Line-Height rules!
            fontSize = '';
        }
        else {
            var tick = 2;
            // Get current font-size.
            var fontSize = editor.css('font-size'); // Font size in pixels!
            fontSize = (parseInt(fontSize) + (params.direction * tick)) + 'px';
        }
        // Reset Or Increase (+) Or decrease (-) font size based on the given parameter.
		editor.css({'font-size' : fontSize, 'line-height' : fontSize});
		blockModel.aceEditor.setOptions({
			fontSize: fontSize
		})
    };


    /**
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_fullscreen  = function(event) {
        // Initialize vars!
        var block = this.block;
        var elementsToDock = $.merge($.merge([], this.extraDocks), this.defaultDocks);
        var newMode = '';
        // Document body.
        $('body').toggleClass('fullscreen').hasClass('fullscreen');
        // Enter/Exit Full Screen mode!
        if (block.box.toggleClass('fullscreen').hasClass('fullscreen')) {
            newMode = 'fullscreen';
            // Defined resize handler.
            var resizer = $.proxy(
                function() {
                    $.each(elementsToDock, $.proxy(
                        function(index, item) {
                            
                            // Dock all defined elements!
                            item.height = this.dock(item.element, item.pixels);
                            
                            item.element.trigger('CJTDockedItemResized', [item]);
                            
                        }, this)
                    );
                }, this);
                // Bind to handler.
            $(window).bind('resize.cjtfullscreen', resizer);
            // Call it.
            resizer();
        }
        else {
            // Reset to normal height.
            $.each(elementsToDock, $.proxy(
            
                function(index, item) {
                    
                    $(item.element).css('height', '');
                    
                    item.element.trigger('CJTBlockExitFullScreen', [item]);
                    
                }, this)
            );
            $(window).unbind('resize.cjtfullscreen');
        }
        
        // Screen mode title.
        $(event.target).attr('title', CJTEETB_Views_Block_ViewToolboxI18N['screenmode_' + newMode + 'Title']);
        // Refresh/Redraw editor.
        block.aceEditor.resize();
        // Toggle Toolbox fullscreen button icon.
        this.editorToolbox.buttons['fullscreen'].jButton.toggleClass('maximized');
    }

    /**
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_metaboxpreview = function() {
        // Save changes and preview changes when successed!
        this._onsavechanges().success(
            function() {
                $('#post-preview').click();
            }
        );
    };

    /**
    * put your comment there...
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_saveeditoroptions = function() {
        // Initialize
        var blockModel = this.block;
        // Save options
        var editorOptions = blockModel.aceEditor.getOptions();
        // Don't save mode as its automatically detected by editor unit.
        delete editorOptions.mode;
        // Don't save theme as it does has standalone extension
        delete editorOptions.theme;
		// Save options
        blockModel.set('aceEditorMenuSettings', editorOptions);
    };

    /**
    *
    *
    *
    *
    */
    CJTBlockPluginBase.prototype._cjteetb_on_toggleobjectspanel = function(event, initialState)
    {
        var toggler = $(event.target);
        var block = this.block;
        var pagesBlock = block.box.find('.cjpageblock');
        var codeBlock = block.box.find('.cjcodeblock');
        var aceEditor = block.aceEditor;
        var newState = '';

        block.box.trigger( 'cjtplustoggleobjectspanel', block );

        // Hide pages panel when:
        if (pagesBlock.css('display') != 'none') {
            // Hide if initial value == undefined or initial value == closed.
            if ((initialState != '') && (initialState != 'undefined')) {
                // Hide elements.
                pagesBlock.css('width', '0px').hide();
                codeBlock.animate({'margin-right' : 0}, undefined, undefined,
                    function() {
                        toggler.addClass('closed');
                        // Refresh editor.
                        aceEditor.resize();
                    }
                );
                // Save state.
                newState = 'closed';
            }
        }
        else {
            // Show elements.
            codeBlock.animate({'margin-right' : 320}, undefined, undefined,
                function() {
                    // Use CSS class margin not inline style!
                    codeBlock.css('margin-right', '');
                    // Show panel!
                    pagesBlock.css('width', '').show();
                    toggler.removeClass('closed');
                    // Refresh editor.
                    aceEditor.resize();
                }
            );
        }

        // Set title based on the new STATE!
        toggler.attr('title', CJTEETB_Views_Block_ViewToolboxI18N['assigmentPanel_' + newState + 'Title']);
        // Save state.
        block.set('pagesPanelToggleState', newState);
        // For link to behave inactive.
        return false;
    };

})(jQuery);